#pragma once

#define		TEXTURE_EXIST		1

#include <vector>

class XResourceManager : public IResourceManager
{
	std::vector <IResource*>		m_arResources;
	std::vector <IVertexBuffer*>	m_arVB;
	std::vector <IIndexBuffer*>		m_arIB;
	std::vector <ID3DXSprite*>		m_arSprites;
	
	DWORD m_dwRef;
	
public:	
	virtual IResource*	AddResource(IResource *pRes, BOOL bUnique);
	virtual IResource*	GetResource(DWORD dwID);

	virtual HRESULT	AddVertexBuffer(IVertexBuffer * pBufferToAdd);
	virtual HRESULT	AddIndexBuffer(IIndexBuffer * pBufferToAdd);
	virtual HRESULT	AddSprite(ID3DXSprite * pSpriteToAdd);
		
	virtual HRESULT	ReleaseAll();
	virtual HRESULT	RestoreAll();
	
	virtual HRESULT		AddRef();
	virtual HRESULT		Release();
public:
	XResourceManager(void);
	~XResourceManager(void);
};
