// Input1.h: interface for the CInput class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#define KEYDOWN(name, key) (name[key] & 0x80)

#define		MOUSEBUTTON_LEFT					0
#define		MOUSEBUTTON_RIGHT					1

#ifndef INPUT_API
     #define INPUT_API __declspec( dllimport )
#endif // INPUT_API

#define		_S_CURSOR		"arrow.tga"

#include "Cursor.h"

class XInput  : public IInput
{
	LPDIRECTINPUT8	m_lpDI;
	LPDIRECTINPUTDEVICE8	m_lpDIDKeyboard;
	// Mouse
	LPDIRECTINPUTDEVICE8	m_lpDIDMouse;

	BOOL	m_bInit;
	BOOL	m_bButtonDown;
	//
	// Rozliseni obrazovky
	D3DXVECTOR2	m_csResolution; 
	//
	// Souradnice kurzoru
	D3DXVECTOR2	m_ptCursor;

	//
	// Pole pro klavesnici + handling
	BYTE	m_arKeyboard[256]; 
	BOOL	m_IsHandled[256]; 

	//
	// Stavova struktura pro mys + handling (2 tl.)
	DIMOUSESTATE	m_MouseState;
	BOOL			m_bIsMouseHandled[2];

	//
	// Cursor
	ICursor*		m_theCursor;
	BOOL			m_bShowCursor;

	DWORD			m_dwRef;
	
public:
	// Common func.
	virtual HRESULT Init(HINSTANCE hInst, HWND hWnd, D3DXVECTOR2* csResolution);
	virtual HRESULT	ProcessInput();
	//
	// Cursor function
	virtual HRESULT UpdateCursor();
	virtual void	ShowCursor(BOOL bShow = TRUE) {m_bShowCursor = bShow;}
	virtual D3DXVECTOR2*	GetCursor() {return &m_ptCursor;}
	//
	// Detection
	virtual BOOL	IsRButtonDown(BOOL _Handling = TRUE);
	virtual BOOL	IsLButtonDown(BOOL _Handling = TRUE);
	virtual BOOL	IsRButtonUp();
	virtual BOOL	IsLButtonUp();
	virtual BOOL	IsKeyDown(int Key, BOOL bHandle = TRUE);	

	virtual HRESULT RestoreDevices();
	
	// interface functions
	virtual HRESULT		AddRef();
	virtual HRESULT		Release();
public:
	XInput();
	~XInput();

private:	
	void	MoveCursor(int dx, int dy) {m_ptCursor.x += dx; m_ptCursor.y += dy;}	
	void	Clean();
};

