/*
 *
 * Manager.cpp - Implementation of manager
 * Date:	4.6.2006
 * Update:	-
 * Author:	Jiri Formanek
 *
 */
#include "StdAfx.h"
#define INPUT_API __declspec(dllexport)

#include "../Common/Common.h"
#include "../Display/Common.h"
#include "Interfaces.h"
#include "Manager.h"
#include "XInput.h"

// Call This function to get desired interface
INPUT_API  HRESULT	CreateInputObject(INPIID InterfaceID, void ** ppv)
{
	// unique objects
	static IInput		* g_theInput = NULL;	
	if(!ppv)
	{
		return ERROR_INVALID_PARAMETER;
	}
	// get pointer according IID 
	switch(InterfaceID) {
		case INPIID_IInput:
			if(!g_theInput) 
			{
				*ppv = g_theInput = new XInput;
			}
			else {
				*ppv = g_theInput;
			}
			((IInput*)(*ppv))->AddRef();
			break;		
		case INPIID_ICursor:				
			*ppv = new XCursor;			
			((ICursor*)(*ppv))->AddRef();
			break;		
		default:
			return E_NOINTERFACE;
	}
	return S_OK;
}