// PruchodKonem1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <iomanip>

using namespace std;

#define SirkaPole	8
#define VyskaPole	8
#define MaxPocetTahu	((SirkaPole * VyskaPole) - 1)

typedef struct {
	int dx;	// zmena v x
	int dy;	// zmena v y
} TahKonem;

TahKonem MozneTahy[8] = { {2, 1}, {1, 2}, {-1, 2}, {-2, 1},
{-2, -1}, {-1, -2}, {1, -2}, {2, -1} };	// osm moznych tahu konem

int Sachovnice[SirkaPole][VyskaPole];

void TiskSachovnice()
{
	for(int i = 0; i < SirkaPole; i++)
	{
		for(int j = 0; j < VyskaPole; j++)
		{
			cout << setw(4) << Sachovnice[i][j];
		}
		cout << endl << endl;
	}
}

void VymazSachovnici()
{
	for(int i = 0; i < SirkaPole; i++)
	{
		for(int j = 0; j < VyskaPole; j++)
		{
			Sachovnice[i][j] = -1;
		}
	}
}

void UdelejTah(int _iCislo, int _PozX, int _PozY, bool *_bTahOK)
{
	int iTah = 0;
	bool bTahOK = false;
	int NoveX, NoveY;
	
	do
	{
		NoveX = _PozX + MozneTahy[iTah].dx;
		NoveY = _PozY + MozneTahy[iTah].dy;
		iTah++;	// priste zkusime dalsi tah

		if((NoveX >= 0) && (NoveX < SirkaPole) && (NoveY >= 0) && (NoveY < VyskaPole))
		{
			// jsme stale na sachovnici
			if(Sachovnice[NoveX][NoveY] == -1)
			{
				// jeste jsme na tomto poli nebyli
				Sachovnice[NoveX][NoveY] = _iCislo;

				if(_iCislo < MaxPocetTahu)	// pokud tah nebyl posledni, zkus dalsi
				{
					// zkusime dalsi tah
					UdelejTah(_iCislo + 1, NoveX, NoveY, &bTahOK);
					
					if(!bTahOK)
					{
						// pokud tah neni mozny, pak ho zrusime - nastavime na -1
						Sachovnice[NoveX][NoveY] = -1;
					}
				}
				else
				{
					bTahOK = true;
				}
			}
		}
	} while (!bTahOK && (iTah < 8));

	*_bTahOK = bTahOK;	// vratime hodnotu pres parametr
}

int main(int argc, char* argv[])
{
	int PozX, PozY;

	cout << "Zadej x souradnici kone: ";
	cin >> PozX;
	cout << "Zadej y souradnici kone: ";
	cin >> PozY;

	if((PozX >= 0) && (PozX < SirkaPole) && (PozY >= 0) && (PozY < VyskaPole))
	{
		VymazSachovnici();

		Sachovnice[PozX][PozY] = 0;	// prvni pole

		bool bOK;

		UdelejTah(1, PozX, PozY, &bOK);

		// pokud ma bOK hodnotu true, mame zaplnenou sachovnici tahy konem - staci ji vytisknout

		if(bOK)
		{
			TiskSachovnice();
		}
		else
		{
			cout << "Cesta konem nebyla nalezena" << endl;
		}
	}
	else
	{
		cout << endl << "Zadana pozice lezi mimo hraci pole" << endl;
	}

	char c;
	cin >> c;

	return 0;
}
