#ifndef CDYNFRONTA_H
  #define CDYNFRONTA_H

  /*template<class T> class CPrvek {
		private:
			T m_Data;
			CPrvek<T> *m_lpDalsi;
		public:
			CPrvek() : m_lpDalsi(NULL) { }
			CPrvek(const T& _Data) : m_Data(_Data), m_lpDalsi(NULL) { }

			T VratData() const { return m_Data; }
			CPrvek<T>* VratDalsi() const { return m_lpDalsi; }
			void NastavDalsi(CPrvek<T> *_lpDalsi) { m_lpDalsi = _lpDalsi; }
			void NastavData(const T& _Data) { m_Data = _Data; }
  };*/

  template<class T> class CDynFronta {
		private:
			CPrvek<T> *m_lpVrchol, *m_lpPosledni;
		public:
			CDynFronta() : m_lpVrchol(NULL), m_lpPosledni(NULL) { }
			~CDynFronta() { if(!JePrazdna()) { SmazFrontu(); } }

			void VytvorPrazdnou();

			bool SmazFrontu();

			bool JePrazdna() { return (m_lpVrchol == NULL); }

			bool Vloz(const T& _Data);	// vklada na zacatek seznamu
			bool Vyjmi(T &_Vyber);	// odebere prvni prvek
  };

  template<class T> void CDynFronta<T>::VytvorPrazdnou()
  {
	  if(m_lpVrchol)
	  {
		  SmazFrontu();
	  }
	  
	  m_lpVrchol = NULL;
	  m_lpPosledni = NULL;
  }

  template<class T> bool CDynFronta<T>::SmazFrontu()
  {
	  bool bNavrat = false;

	  if(!JePrazdna())
	  {
		  CPrvek<T> *lpMazany;
		  
		  while(m_lpVrchol)
		  {
			  lpMazany = m_lpVrchol;
			  m_lpVrchol = m_lpVrchol->VratDalsi();	// posun na dalsi prvek
			  delete lpMazany;
		  }

		  bNavrat = true;
	  }

	  return bNavrat;
  }

  template<class T> bool CDynFronta<T>::Vloz(const T& _Data)
  {
	  bool bNavrat = false;

	  // jen vlozime prvek do zasobniku
	  CPrvek<T> *lpNovy = new CPrvek<T>(_Data);

	  if(lpNovy)
	  {
		  if(m_lpVrchol == NULL)	// je to tedy prvni prvek
		  {
			  m_lpVrchol = lpNovy;
			  m_lpPosledni = lpNovy;	// zacatek i konec jsou si rovny
		  }
		  else
		  {
			  m_lpPosledni->NastavDalsi(lpNovy);
			  m_lpPosledni = lpNovy;
		  }

		  bNavrat = true;
	  }

	  // opet novy prvek nemazeme
	
	  return bNavrat;
  }

  template<class T> bool CDynFronta<T>::Vyjmi(T &_Vyber)
  {
	  bool bNavrat = false;

	  if(!JePrazdna())
	  {
		  _Vyber = m_lpVrchol->VratData();

		  CPrvek<T> *lpMazany = m_lpVrchol;
		  m_lpVrchol = m_lpVrchol->VratDalsi();

		  delete lpMazany;

		  bNavrat = true;
	  }

	  return bNavrat;
  }
  
#endif
